// Generated by CoffeeScript 1.6.3
var app, args, compile, compilers, conf, confs, credentials, err, error, exec, fs, k, opt, opts, os, server, usage, utils, v, websocket, _i, _len, _ref, _ref1;

exec = require('executive');

fs = require('fs');

os = require('os');

error = function(message) {
  console.error(message);
  return process.exit(1);
};

usage = function() {
  console.log("bebop [options]\n\nOptions:\n  --host, -h      Hostname to bind to\n  --port, -p      Port to listen on\n  --secure, -s    Require authentication\n  --open, -o      Open browser automatically\n  --no-watch      Do not watch files for changes\n  --no-compile    Do not compile files automatically\n  --force-compile Compile files and exit");
  return process.exit(0);
};

opts = {
  compile: true,
  host: '0.0.0.0',
  port: 3000,
  watch: true
};

confs = [process.env.HOME + '/.bebop', process.cwd() + '/.bebop'];

require.extensions['.coffee'] = function() {
  require('coffee-script');
  return require.extensions['.coffee'].apply(require.extensions, arguments);
};

for (_i = 0, _len = confs.length; _i < _len; _i++) {
  conf = confs[_i];
  try {
    conf = require.resolve(conf);
  } catch (_error) {
    err = _error;
    continue;
  }
  if (fs.existsSync(conf)) {
    _ref = require(conf);
    for (k in _ref) {
      v = _ref[k];
      opts[k] = v;
    }
  }
}

args = process.argv.slice(2);

while (opt = args.shift()) {
  switch (opt) {
    case '--help':
    case '-v':
      usage();
      break;
    case '--open':
    case '-o':
      opts.openBrowser = true;
      break;
    case '--no-watch':
      opts.watch = false;
      break;
    case '--no-compile':
      opts.compile = false;
      break;
    case '--force-compile':
      opts.forceCompile = true;
      break;
    case '--host':
    case '-h':
      opts.host = args.shift();
      break;
    case '--port':
    case '-p':
      opts.port = parseInt(args.shift(), 10);
      break;
    case '--secure':
    case '-s':
      credentials = args.shift();
      if (credentials) {
        _ref1 = credentials.split(':'), opts.user = _ref1[0], opts.pass = _ref1[1];
      } else {
        opts.user = 'bebop';
        opts.pass = 'beepboop';
      }
      break;
    default:
      if (opt.charAt(0) === '-') {
        error('Unrecognized option');
      }
  }
}

compilers = require('./compilers');

server = require('./server');

utils = require('./utils');

compile = function(filename, cb) {
  if (cb == null) {
    cb = function() {};
  }
  return compilers.compile(filename, function(err, compiled) {
    if (err != null) {
      console.error(err.toString());
      console.error(err.stack);
      return;
    }
    if (compiled) {
      utils.log("  compiled\x1B[0m " + filename);
      return cb(null);
    }
  });
};

(require('vigil')).walk(process.cwd(), function(filename) {
  return compile(filename);
});

if (!opts.forceCompile) {
  app = server.createServer(opts);
  if (opts.watch) {
    websocket = (require('./websocket'))({
      server: app
    });
    (require('vigil')).watch(process.cwd(), function(filename, stat, isModule) {
      utils.log("  modified\x1B[0m " + filename);
      if (!opts.compile) {
        return websocket.modified(filename);
      }
      return compile(filename, function(err, compiled) {
        if (!compiled) {
          return websocket.modified(filename);
        }
      });
    });
  }
  app.run();
  if (opts.openBrowser) {
    switch (os.platform()) {
      case 'darwin':
        exec("open http://" + opts.host + ":" + opts.port);
        break;
      case 'linux':
        exec("xdg-open http://" + opts.host + ":" + opts.port);
    }
  }
}

/*
//@ sourceMappingURL=cli.map
*/
